<?php

global $gfilters;
global $old_gfilters;
$old_gfilters = $_SESSION['gfilters'];
$input_errors = array();

function ProcessDate($paramname, $default) {
    global $old_gfilters;
    $result = isset($old_gfilters[$paramname]) ? $old_gfilters[$paramname]
                                               : $default;
    if(isset($_POST[$paramname])){
        $d = explode('.', $_POST[$paramname]);
        $input_errors[$paramname] = (count($d) >= 3) ? !checkdate($d[1], $d[0], $d[2])
                                                     : true;
        if(!$input_errors[$paramname]){
            $result = $d[2] . "-" . $d[1] . "-" . $d[0];
            return $result;
        }
    } else $input_errors[$paramname] = false;
    return $result;
}

function ProcessParam($paramname, $default){
    global $old_gfilters;
    if(isset($_POST[$paramname])) return $_POST[$paramname];
    return isset($old_gfilters[$paramname]) ? $old_gfilters[$paramname]
                                            : $default;
}

function GetWhereFilter($filterkey){
    global $gfilters;
    if(isset($gfilters[$filterkey])){
        switch ($filterkey) {
            case 'data-start': 
                    $result = '(timeofcall>="' . mysql_escape_string($gfilters[$filterkey]) . '")';            
                break;
            
            
            case 'data-end': 
                    $result = '(timeofcall<="' . mysql_escape_string($gfilters[$filterkey]) . ' 23:59:29")';            
                break;
            
            
            case 'ats': 
                    if($gfilters['ats'] != -1) $result = '(pbxid=' . mysql_escape_string($gfilters[$filterkey]) . ')';            
                    else $result = '';
                break;
            
            
            case 'direction': 
                    if($gfilters['direction'] != -1) $result = '(incoming=' . mysql_escape_string($gfilters[$filterkey]) . ')';            
                    else $result = '';
                break;
            
            
            case 'extonly': 
                    if($gfilters['extonly'] != 0) $result = '(LENGTH(co) > 0)';            
                    else $result = '';
                break;
            
            
            case 'co': 
                    if($gfilters['co'] != '') {
                        $numbs = explode(',', $gfilters[$filterkey]);
                        $result = '(false ';
                        foreach ($numbs as $value) {
                            $result .= ' OR (co like "' . mysql_escape_string($value) . '%")'; 
                        }
                        $result .= ')';            
                    }
                    else $result = '';
                break;
            
            
            case 'numclass': 
                    if($gfilters['numclass'] != '') $result = '(dialnum like "' . mysql_escape_string($gfilters[$filterkey]) . '")';            
                    else $result = '';
                break;
            
            
            case 'ext': 
                    if($gfilters['ext'] != '') {
                        $numbs = explode(',', $gfilters[$filterkey]);
                        $result = '(false ';
                        foreach ($numbs as $value) {
                            $result .= ' OR (ext like "' . mysql_escape_string($value) . '%")'; 
                        }
                        $result .= ')';            
                    }
                    else $result = '';
                break;
            
            
            case 'dialnum': 
                    if($gfilters['dialnum'] != '') {
                        $numbs = explode(',', $gfilters[$filterkey]);
                        $result = '(false ';
                        foreach ($numbs as $value) {
                            $result .= ' OR (dialnum like "' . mysql_escape_string($value) . '%")'; 
                        }
                        $result .= ')';            
                    }
                    else $result = '';
                break;
            
            
            default: 
                if(isset($gfilters[$filterkey]) and ($gfilters[$filterkey] !='')) $result = '(' . $filterkey . '=' . mysql_escape_string($gfilters[$filterkey]) . ')';
                else $result = ''; 
                break;
            
                
        }
        return $result;
          
    } else return '';
}

function GetGlobalWhere(){
    global $gfilters;
    foreach ($gfilters as $key => $value) {
        $filter = GetWhereFilter($key);
        if($filter !=''){
            if($result !='') $result .= ' AND ' . $filter;
            else $result = $filter;
        }
    }
    if($result != '') return '(' . $result . ')';
    else return '';
}

function SecondToStr($time){
    if($time >= 60*60*24) return gmdate('d д. H:i:s', $time);
    else return gmdate('H:i:s', $time);
}

function makecheckbox($param){
    list($name, $checked) = explode('-', $param);
    if($checked) $checked = 'checked';
    else $checked = '';
    return "<input type=checkbox value=1 name=" . $name . " " . $checked . ">";
}

    
      
    $gfilters['data-start'] = ProcessDate('data-start', date('Y-m-d', time() - (3600*24*30)));
    $gfilters['data-end'] = ProcessDate('data-end', date('Y-m-d'));
    $gfilters['ats'] = ProcessParam('ats', -1);
    $gfilters['direction'] = ProcessParam('direction', 0);
    $gfilters['extonly'] = isset($_POST['data-start']) ? isset($_POST['extonly'])
                                                       : $old_gfilters['extonly']; 
    $gfilters['co'] = ProcessParam('co', '');
    $gfilters['numclass'] = ProcessParam('numclass', '');
    $gfilters['ext'] = ProcessParam('ext', '');
    $gfilters['dialnum'] = ProcessParam('dialnum', '');
    $_SESSION['gfilters'] = $gfilters;
?>
